s = Server.local;
b = Buffer.alloc(s, 44100 * 4.0, 1); // a four second 1 channel Buffer

// recording synth
(
SynthDef("recBuf",{ arg bufnum=0;
	var in;
	in = SoundIn.ar(0);
	RecordBuf.ar(in, bufnum);
}).load;
)

// playing synth
(
SynthDef("playBuf",{ arg bufnum=0;
	var signal, out=0;
	signal = PlayBuf.ar(1, bufnum);
	Out.ar(out, signal)
}).load;
)

// we record into the buffer
x = Synth("recBuf", b.bufnum);
x.free;

// play it back
z = Synth("playBuf",  b.bufnum);
z.free;